function [CF_drive] = get_CF_drive
% [CF_drive] = get_CF_drive
% function takes no inputs and returns the letter of the CF drive
% it also checks to see that the CF drive is indeed removable

CF_drive = 'G';
% this first line will need to be modified by the user to name the drive 
% letter of the CF drive. This is very important!!! even though there is 
% some error checking, if this is wrong, bad things may happen!

% check to make sure the drive is removable
% step 1 - issue an operating system command to get the drive type
[s, drive_type] = dos(['fsutil fsinfo drivetype ' CF_drive ':']);
% step 2 - see if drive type contains string - 'removable drive'
if (s == 0)  % above command succedded
    idx = strfind(lower(drive_type), 'removable drive');
    if (length(idx) == 0) % match has not been been found
        CF_drive = -1;  % set to error 
    else
        display(['CF drive selected is drive ' CF_drive ' which is a removable drive']);
    end
    
else
    CF_drive = -1;      % set to error 
end